Bug 96969 - Change column selection keyboard shortcut to Ctrl+Space
Summary: Change column selection keyboard shortcut to Ctrl+Space
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: All All
: medium enhancement
Assignee: Not Assigned
QA Contact:
URL:
Whiteboard: target:5.2.0 target:5.3.0
Keywords:
Depends on:
Blocks: 92453 Shortcuts-Accelerators
  Show dependency treegraph
 
Reported: 2016-01-08 20:45 UTC by Óvári
Modified: 2016-10-25 18:54 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Óvári 2016-01-08 20:45:42 UTC
This is a suggestion to change the entire column selection keyboard shortcut.

The current entire row selection is Ctrl+Shift+Space.

This suggestion is to change it to Ctrl+Space.

1. Accessibility improvement
2. Usability improvement
3. Entire row is only 2 keys, i.e. Shift+Space
4. Selecting all cells in a Sheet can then be the combination of entire row + entire column keyboard shortcuts, i.e.
   a. Ctrl+Space         {Selects entire column}
      Shift+Space        {Selects entire Sheet}
   b. Shift+Space        {Selects entire row}
      Ctrl+Space         {Selects entire Sheet}
   c. Ctrl+Shift+Space   {Selects entire Sheet}

Perhaps this is an EasyHack?

Thank you

Version: 5.2.0.0.alpha0+
Build ID: 22e5170af74c635cf55d089f97946b6dc86f82ad
CPU Threads: 2; OS Version: Windows 6.2; UI Render: default; 
TinderBox: Win-x86@62-merge-TDF, Branch:MASTER, Time: 2016-01-05_23:41:26
Comment 1 Cor Nouws 2016-01-08 23:18:57 UTC
Intersting idea, Óvári..
I don't see a problem in it, but not sure if there isn't any.
What are people used to from other spread sheet applications?
As such, Ctrl+Shft+Space is not a problem. But indeed, Ctrl+Spase is indeed easier..

Opinions?
Comment 2 Óvári 2016-01-09 00:29:04 UTC
(In reply to Cor Nouws from comment #1)
> What are people used to from other spread sheet applications?

Google Sheets and MS Excel have:
Ctrl+Space           Select column(s)
Shift+Space          Select row(s)
Ctrl+Shift+Space     Select Sheet

Could not find how to select multiple sheets in Google Sheets; however, MS Excel can select multiple sheets:
Ctrl+Shift+Space     Select Sheet(s)
Comment 3 Yousuf Philips (jay) 2016-02-29 05:53:38 UTC
(In reply to Óvári from comment #0)
> Perhaps this is an EasyHack?

Yes it is simple enough to associate Ctrl+Space with column selection as the shortcut is not currently used in Calc, but do we want to keep Ctrl+Shift+Space as is or change it to an alternative sheet select to supplement Ctrl+A?

(In reply to Óvári from comment #2)
> Google Sheets and MS Excel have:
> Ctrl+Space           Select column(s)
> Shift+Space          Select row(s)
> Ctrl+Shift+Space     Select Sheet

Gnumeric also uses these shortcuts, though Ctrl + A is the primary shortcut used to select Excel and Google Sheets for selecting a sheet

> Could not find how to select multiple sheets in Google Sheets; however, MS
> Excel can select multiple sheets:
> Ctrl+Shift+Space     Select Sheet(s)

Not sure how Excel could use the same shortcut for both selecting a sheet and selecting multiple sheets.
Comment 4 Óvári 2016-02-29 21:28:43 UTC
(In reply to Yousuf (Jay) Philips from comment #3)
> Do we want to keep
> Ctrl+Shift+Space as is or change it to an alternative sheet select to
> supplement Ctrl+A?

Please change to alternative sheet select to supplement Ctrl+A

> (In reply to Óvári from comment #2)
> > Google Sheets and MS Excel have:
> > Ctrl+Space           Select column(s)
> > Shift+Space          Select row(s)
> > Ctrl+Shift+Space     Select Sheet
> 
> Gnumeric also uses these shortcuts, though Ctrl + A is the primary shortcut
> used to select Excel and Google Sheets for selecting a sheet

Perhaps it is the primary shortcut for keyboards that use the ISO basic Latin alphabet.
https://en.wikipedia.org/wiki/ISO_basic_Latin_alphabet

Having LO by default support these would assist people using a keyboard with an Arabic keyboard layout:
https://img.quizlet.com/HrQnx-o.jpg
https://en.wikipedia.org/wiki/Arabic_keyboard

Perhaps in the Edit menu of Calc, if LO is aware of the current keyboard layout being used, it could show "Ctrl+Shift+Space" next to "Select All" for keyboards that do not have an 'A'.

> 
> > Could not find how to select multiple sheets in Google Sheets; however, MS
> > Excel can select multiple sheets:
> > Ctrl+Shift+Space     Select Sheet(s)
> 
> Not sure how Excel could use the same shortcut for both selecting a sheet
> and selecting multiple sheets.

For a Excel Workbook that has 3 sheets, opened at Sheet 1:
1. Press Ctrl+Shift+PgDn twice.
   You should now have all three sheets selected.
2. Press Ctrl+Shift+Space.
   You have now selected all elements in all three sheets.
3. Change the font face, font size, alignment, etc.
   You have now changed this for all elements in all three sheets.

If you require any further explanations, please advise.

Thank you
Comment 5 Yousuf Philips (jay) 2016-03-01 03:30:41 UTC
(In reply to Óvári from comment #4)
> (In reply to Yousuf (Jay) Philips from comment #3)
> > Do we want to keep
> > Ctrl+Shift+Space as is or change it to an alternative sheet select to
> > supplement Ctrl+A?
> 
> Please change to alternative sheet select to supplement Ctrl+A

Just found out that Cmd + Shift + Space doesnt work on Mac, which means it is another good reason to change this. Bad news is that Cmd + Space also doesnt work on Mac, so on Mac it will be the same combination of Ctrl + Space and Ctrl + Shift + Space as on Windows/Linux.

> > Gnumeric also uses these shortcuts, though Ctrl + A is the primary shortcut
> > used to select Excel and Google Sheets for selecting a sheet
> 
> Perhaps it is the primary shortcut for keyboards that use the ISO basic
> Latin alphabet.
> https://en.wikipedia.org/wiki/ISO_basic_Latin_alphabet

It is the primary shortcut as both Windows and Mac both specify in their UI guidelines that it is the default shortcut for it.

> Having LO by default support these would assist people using a keyboard with
> an Arabic keyboard layout:
> https://img.quizlet.com/HrQnx-o.jpg
> https://en.wikipedia.org/wiki/Arabic_keyboard

My keyboard is English/Arabic. :D

> Perhaps in the Edit menu of Calc, if LO is aware of the current keyboard
> layout being used, it could show "Ctrl+Shift+Space" next to "Select All" for
> keyboards that do not have an 'A'.

LO states in its shortcuts documentation that Ctrl+A is for "Select All", so that wont be changing in the Edit menu.

> For a Excel Workbook that has 3 sheets, opened at Sheet 1:
> 1. Press Ctrl+Shift+PgDn twice.
>    You should now have all three sheets selected.
> 2. Press Ctrl+Shift+Space.
>    You have now selected all elements in all three sheets.
> 3. Change the font face, font size, alignment, etc.
>    You have now changed this for all elements in all three sheets.

You stated "... MS Excel can select multiple sheets: Ctrl+Shift+Space" which is where the confusion happened as you didnt say that you had to first select the sheets before doing the shortcut in order to select the contents of the selected sheets. This also works in Calc with ctrl+A after step 1.

Patch is in - https://gerrit.libreoffice.org/22795
Comment 6 Cor Nouws 2016-03-01 08:05:18 UTC
(In reply to Yousuf (Jay) Philips from comment #3)

> Yes it is simple enough to associate Ctrl+Space with column selection as the
> shortcut is not currently used in Calc, but do we want to keep
> Ctrl+Shift+Space as is or change it to an alternative sheet select to
> supplement Ctrl+A?

Is there a reason to want to supplement Ctrl+A ?
Comment 7 Yousuf Philips (jay) 2016-03-01 08:52:09 UTC
(In reply to Cor Nouws from comment #6)
> Is there a reason to want to supplement Ctrl+A ?

I would assume that if a user is used to selecting things with Ctrl + Space and Shift + Space, they would likely be more used to using Ctrl + Shift + Space than Ctrl + A.
Comment 8 Óvári 2016-03-01 09:33:13 UTC
(In reply to Yousuf (Jay) Philips from comment #7)
> (In reply to Cor Nouws from comment #6)
> > Is there a reason to want to supplement Ctrl+A ?
> 
> I would assume that if a user is used to selecting things with Ctrl + Space
> and Shift + Space, they would likely be more used to using Ctrl + Shift +
> Space than Ctrl + A.

Your assumption is correct Jay. Thank you
Comment 9 Commit Notification 2016-03-06 14:03:41 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=e5f56d0c6e2a7d75a1f5ee27550b1270641da977

tdf#96969 Calc: Change shortcut key for Select Column

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 10 Óvári 2016-03-07 05:14:39 UTC
(In reply to Commit Notification from comment #9)
> Affected users are encouraged to test the fix and report feedback.

Partially works with:
Version: 5.2.0.0.alpha0+
Build ID: b89feb8018bf3610faf01e73995d576f6566e20b
CPU Threads: 2; OS Version: Windows 6.29; UI Render: default; 
TinderBox: Win-x86@39, Branch:master, Time: 2016-03-07_03:36:17

Enabling keyboard shortcuts to work when creating formulae yet to be implemented, eg.
Bug 92453 - Entire column functionality in formulae keyboard shortcuts

As bug 96969 enhancement has been partially implemented should bug 96969 be set to fixed?

Thank you
Comment 11 Yousuf Philips (jay) 2016-03-07 12:27:15 UTC
(In reply to Óvári from comment #10)
> Partially works with:
> Version: 5.2.0.0.alpha0+
> Build ID: b89feb8018bf3610faf01e73995d576f6566e20b
> CPU Threads: 2; OS Version: Windows 6.29; UI Render: default; 
> TinderBox: Win-x86@39, Branch:master, Time: 2016-03-07_03:36:17

Not sure how this is partially working as they work fine for me.

> Enabling keyboard shortcuts to work when creating formulae yet to be
> implemented, eg.
> Bug 92453 - Entire column functionality in formulae keyboard shortcuts

That is a separate issue from the standard shortcuts being handled here and that can be continued in the bug report.
Comment 12 pierre-yves samyn 2016-04-17 07:14:21 UTC
Hi

Sorry to bring this comment probably quite late. 

I agree to simplify this shortcut but keep the old (Ctrl+Shift+Space) seems to me useful: on most keyboards Ctrl and Shift are one above the other, which is a useful visual mnemonic to differentiate column selection of row selection.

In other words I'm pretty sure never to use the new shortcut if the old one is still available and that not by habit but by my inability to remember whether to use Ctrl or Shift to this or that action.

My 2 cents...

Regards
Comment 13 water.qian 2016-06-24 00:09:31 UTC
This might be an unfortunate change for some International users, e.g. for China users, where the Ctrl+Space is the Windows system shortcut for Input method switching.  

Change from Ctrl+Shift+Space to Ctrl+Space makes the column selection shortcut stop working.
Comment 14 Óvári 2016-06-24 03:09:43 UTC
(In reply to water.qian from comment #13)
> Change from Ctrl+Shift+Space to Ctrl+Space makes the column selection
> shortcut stop working.
Sorry to hear that this feature does not provide a good experience with the Chinese version of Windows. It is hoped that the following could help in your transition to <Ctrl>+<Space> for column selection keyboard shortcut.

The Windows system shortcut for Input method switching is <Win>+<Space> for Windows 8.1 and Windows 10.
Is it possible to use <Win>+<Space>?
<Ctrl>+<Space> is a hot key for between Chinese (Traditional) ↔ Chinese (Simplified).
http://www.pinyinjoe.com/windows-10/windows-10-chinese-advanced-language-bar-ime-pad-hotkeys.htm

Microsoft themselves do not provide a good experience for their own ecosystem as <Ctrl>+<Space> also conflicts with Microsoft programs (Word, Visual Studio, et cetera).
It may due the to the legacy when keyboards did not have the <Win>/<Super> key.
“It conflicts with CTRL+Space in the Visual Studio IDE, and is pretty annoying beyond that.”
http://superuser.com/questions/327479/ctrl-space-always-toggles-chinese-ime-windows-7

Perhaps Microsoft is transiting from <Left Alt>+<Shift> to using <Win>+<Space>.
http://www.digitalcitizen.life/introducing-windows-8-how-switch-between-keyboard-input-languages

In Linux Mint, the IME change be set to <Super>+<Space> (if it is not set to that by default). <Super> is the reference to the <Win> key. Perhaps other Linux distos can do this too?

Using the <Win>/<Super> key for changing the IME seems appropriate as:
1. it is an operating system feature; and
2. it frees the <Ctrl> and <Alt> keys for programs/applications.

Please see comment 3, comment 5 and comment 7 for rudimentary reasons for using <Ctrl>+<Space>.

Thank you
Comment 15 Óvári 2016-06-24 03:11:00 UTC
Status: Resolved → Verified
Version: 5.2.0.1 (x64)
Build ID: fcbcb4963bda8633ba72bd2108ca1e802aad557d
CPU Threads: 2; OS Version: Windows 6.29; UI Render: default
Comment 16 Cor Nouws 2016-06-24 09:12:14 UTC
(In reply to Óvári from comment #14)
> (In reply to water.qian from comment #13)
> > Change from Ctrl+Shift+Space to Ctrl+Space makes the column selection
> > shortcut stop working.
> Sorry to hear that this feature does not provide a good experience with the
> Chinese version of Windows. It is hoped that the following could help in
> your transition to <Ctrl>+<Space> for column selection keyboard shortcut.

If not: IIRC it is possible to have locale-dependent short cuts?
Comment 17 Yousuf Philips (jay) 2016-06-27 16:49:36 UTC
(In reply to water.qian from comment #13)
> This might be an unfortunate change for some International users, e.g. for
> China users, where the Ctrl+Space is the Windows system shortcut for Input
> method switching.  

So lets retain the old shortcut for chinese.

https://gerrit.libreoffice.org/26725
Comment 18 Commit Notification 2016-06-27 20:28:21 UTC
Yousuf Philips committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4318931ac9993527b7ae24a1284903db91254989

tdf#96969 Use Ctrl+Shift+Space for Select Column in Chinese

It will be available in 5.3.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.